'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mime = require('./mime/mime');

var _mime2 = _interopRequireDefault(_mime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _checkIsNeedConcat(url) {
    var isNeedConcat = false;
    url.indexOf('??') > 0 ? isNeedConcat = true : isNeedConcat = false;
    return isNeedConcat;
}

var Concat = function () {
    function Concat(options) {
        _classCallCheck(this, Concat);

        this.options = options;
        this.init = this.init.bind(this);
    }

    _createClass(Concat, [{
        key: 'concatFile',
        value: function () {
            var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(url) {
                var urlSplit, urlPrefix, urlFiles, files, staticPath, fileBufferArray, contentType, i, len, fileI, enter;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                urlSplit = url.split('??');
                                urlPrefix = urlSplit[0];
                                urlFiles = urlSplit[1].split('?')[0];
                                files = urlFiles.split(',');
                                staticPath = this.options.staticPath;
                                fileBufferArray = [];
                                contentType = files[0].split('.')[1];
                                i = 0, len = files.length;

                            case 8:
                                if (!(i < len)) {
                                    _context.next = 17;
                                    break;
                                }

                                _context.next = 11;
                                return _fs2.default.readFileSync(staticPath + urlPrefix + files[i]);

                            case 11:
                                fileI = _context.sent;

                                if (i > 0 && i < len) {
                                    enter = new Buffer.from([0x0a]);

                                    fileBufferArray.push(enter);
                                }
                                fileBufferArray.push(fileI);

                            case 14:
                                i++;
                                _context.next = 8;
                                break;

                            case 17:
                                return _context.abrupt('return', { bf: Buffer.concat(fileBufferArray), contentType: contentType });

                            case 18:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function concatFile(_x) {
                return _ref.apply(this, arguments);
            }

            return concatFile;
        }()
    }, {
        key: 'init',
        value: function () {
            var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(ctx, next) {
                var isNeedConcat, concatResult;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                isNeedConcat = _checkIsNeedConcat(ctx.req.url);

                                if (!isNeedConcat) {
                                    _context2.next = 9;
                                    break;
                                }

                                _context2.next = 4;
                                return this.concatFile(ctx.req.url);

                            case 4:
                                concatResult = _context2.sent;

                                ctx.response.set('Content-Type', _mime2.default[concatResult.contentType]);
                                ctx.body = concatResult.bf.toString('utf8');
                                _context2.next = 11;
                                break;

                            case 9:
                                _context2.next = 11;
                                return next();

                            case 11:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function init(_x2, _x3) {
                return _ref2.apply(this, arguments);
            }

            return init;
        }()
    }]);

    return Concat;
}();

exports.default = Concat;